Index: issm/trunk/src/c/classes/Elements/Tria.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 26744)
@@ -3444,4 +4095,327 @@
 }
 /*}}}*/
+void	      Tria::MovingFrontalVelocity(void){/*{{{*/
+
+	int  dim, domaintype, calvinglaw, i;
+	IssmDouble v[3],w[3],c[3],m[3],dlsf[3];
+	IssmDouble norm_dlsf, norm_calving, calvingrate, meltingrate, groundedice;
+	IssmDouble migrationmax, calvinghaf, heaviside, haf_eps;
+	IssmDouble  xyz_list[NUMVERTICES][3];
+	IssmDouble  movingfrontvx[NUMVERTICES];
+	IssmDouble  movingfrontvy[NUMVERTICES];
+	IssmDouble  vel;
+
+	/* Get node coordinates and dof list: */
+	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
+
+	Input* vx_input           = NULL;
+	Input* vy_input           = NULL;
+	Input* calvingratex_input = NULL;
+	Input* calvingratey_input = NULL;
+	Input* lsf_slopex_input   = NULL;
+	Input* lsf_slopey_input   = NULL;
+	Input* calvingrate_input  = NULL;
+	Input* meltingrate_input  = NULL;
+	Input* gr_input           = NULL;
+
+	/*Get problem dimension and whether there is moving front or not*/
+	this->FindParam(&domaintype,DomainTypeEnum);
+	this->FindParam(&calvinglaw,CalvingLawEnum);
+
+	switch(domaintype){
+		case Domain2DverticalEnum:   dim = 1; break;
+		case Domain2DhorizontalEnum: dim = 2; break;
+		case Domain3DEnum:           dim = 2; break;
+		default: _error_("mesh "<<EnumToStringx(domaintype)<<" not supported yet");
+	}
+	/*Load velocities*/
+	switch(domaintype){
+		case Domain2DverticalEnum:
+			vx_input=this->GetInput(VxEnum); _assert_(vx_input);
+			break;
+		case Domain2DhorizontalEnum:
+			vx_input=this->GetInput(VxEnum); _assert_(vx_input);
+			vy_input=this->GetInput(VyEnum); _assert_(vy_input);
+			gr_input=this->GetInput(MaskOceanLevelsetEnum); _assert_(gr_input);
+			break;
+		case Domain3DEnum:
+			vx_input=this->GetInput(VxAverageEnum); _assert_(vx_input);
+			vy_input=this->GetInput(VyAverageEnum); _assert_(vy_input);
+			gr_input=this->GetInput(MaskOceanLevelsetEnum); _assert_(gr_input);
+			break;
+		default: _error_("mesh "<<EnumToStringx(domaintype)<<" not supported yet");
+	}
+
+	switch(calvinglaw){
+		case DefaultCalvingEnum:
+		case CalvingVonmisesEnum:
+			lsf_slopex_input  = this->GetInput(LevelsetfunctionSlopeXEnum); _assert_(lsf_slopex_input);
+			if(dim==2) lsf_slopey_input  = this->GetInput(LevelsetfunctionSlopeYEnum); _assert_(lsf_slopey_input);
+			calvingrate_input = this->GetInput(CalvingCalvingrateEnum);     _assert_(calvingrate_input);
+			meltingrate_input = this->GetInput(CalvingMeltingrateEnum);     _assert_(meltingrate_input);
+			break;
+		case CalvingLevermannEnum:
+			switch(domaintype){
+				case Domain2DverticalEnum:
+					calvingratex_input=this->GetInput(CalvingratexEnum); _assert_(calvingratex_input);
+					break;
+				case Domain2DhorizontalEnum:
+					calvingratex_input=this->GetInput(CalvingratexEnum); _assert_(calvingratex_input);
+					calvingratey_input=this->GetInput(CalvingrateyEnum); _assert_(calvingratey_input);
+					break;
+				case Domain3DEnum:
+					calvingratex_input=this->GetInput(CalvingratexAverageEnum); _assert_(calvingratex_input);
+					calvingratey_input=this->GetInput(CalvingrateyAverageEnum); _assert_(calvingratey_input);
+					break;
+				default: _error_("mesh "<<EnumToStringx(domaintype)<<" not supported yet");
+			}
+			meltingrate_input = this->GetInput(CalvingMeltingrateEnum);     _assert_(meltingrate_input);
+			break;
+		case CalvingMinthicknessEnum:
+			lsf_slopex_input  = this->GetInput(LevelsetfunctionSlopeXEnum); _assert_(lsf_slopex_input);
+			if(dim==2) lsf_slopey_input  = this->GetInput(LevelsetfunctionSlopeYEnum); _assert_(lsf_slopey_input);
+			meltingrate_input = this->GetInput(CalvingMeltingrateEnum);     _assert_(meltingrate_input);
+			break;
+		case CalvingHabEnum:
+			lsf_slopex_input  = this->GetInput(LevelsetfunctionSlopeXEnum); _assert_(lsf_slopex_input);
+			if(dim==2) lsf_slopey_input  = this->GetInput(LevelsetfunctionSlopeYEnum); _assert_(lsf_slopey_input);
+			meltingrate_input = this->GetInput(CalvingMeltingrateEnum);     _assert_(meltingrate_input);
+			break;
+		case CalvingCrevasseDepthEnum:
+			lsf_slopex_input  = this->GetInput(LevelsetfunctionSlopeXEnum); _assert_(lsf_slopex_input);
+			if(dim==2) lsf_slopey_input  = this->GetInput(LevelsetfunctionSlopeYEnum); _assert_(lsf_slopey_input);
+			meltingrate_input = this->GetInput(CalvingMeltingrateEnum);     _assert_(meltingrate_input);
+			break;
+		case CalvingDev2Enum:
+			this->FindParam(&calvinghaf,CalvingHeightAboveFloatationEnum);
+			lsf_slopex_input  = this->GetInput(LevelsetfunctionSlopeXEnum); _assert_(lsf_slopex_input);
+			if(dim==2) lsf_slopey_input  = this->GetInput(LevelsetfunctionSlopeYEnum); _assert_(lsf_slopey_input);
+			calvingrate_input = this->GetInput(CalvingCalvingrateEnum);     _assert_(calvingrate_input);
+			meltingrate_input = this->GetInput(CalvingMeltingrateEnum);     _assert_(meltingrate_input);
+			break;
+		default:
+			_error_("Calving law "<<EnumToStringx(calvinglaw)<<" not supported yet");
+	}
+
+	/* Start looping on the number of vertices: */
+	GaussTria gauss;
+	for(int iv=0;iv<NUMVERTICES;iv++){
+		gauss.GaussVertex(iv);
+
+		/* Advection */
+		vx_input->GetInputValue(&v[0],&gauss);
+		vy_input->GetInputValue(&v[1],&gauss);
+		gr_input->GetInputValue(&groundedice,&gauss);
+
+		/*Get calving speed*/
+		switch(calvinglaw){
+			case DefaultCalvingEnum:
+			case CalvingVonmisesEnum:
+				lsf_slopex_input->GetInputValue(&dlsf[0],&gauss);
+				if(dim==2) lsf_slopey_input->GetInputValue(&dlsf[1],&gauss);
+				calvingrate_input->GetInputValue(&calvingrate,&gauss);
+				meltingrate_input->GetInputValue(&meltingrate,&gauss);
+				if(groundedice<0) meltingrate = 0.;
+
+				norm_dlsf=0.;
+				for(i=0;i<dim;i++) norm_dlsf+=pow(dlsf[i],2);
+				norm_dlsf=sqrt(norm_dlsf);
+
+				if(norm_dlsf>1.e-10)
+				 for(i=0;i<dim;i++){
+					 c[i]=calvingrate*dlsf[i]/norm_dlsf; m[i]=meltingrate*dlsf[i]/norm_dlsf;
+				 }
+				else
+				 for(i=0;i<dim;i++){
+					 c[i]=0.; m[i]=0.;
+				 }
+				break;
+
+			case CalvingLevermannEnum:
+				calvingratex_input->GetInputValue(&c[0],&gauss);
+				if(dim==2) calvingratey_input->GetInputValue(&c[1],&gauss);
+				meltingrate_input->GetInputValue(&meltingrate,&gauss);
+				norm_calving=0.;
+				for(i=0;i<dim;i++) norm_calving+=pow(c[i],2);
+				norm_calving=sqrt(norm_calving)+1.e-14;
+				for(i=0;i<dim;i++) m[i]=meltingrate*c[i]/norm_calving;
+				break;
+
+			case CalvingMinthicknessEnum:
+				lsf_slopex_input->GetInputValue(&dlsf[0],&gauss);
+				if(dim==2) lsf_slopey_input->GetInputValue(&dlsf[1],&gauss);
+				meltingrate_input->GetInputValue(&meltingrate,&gauss);
+
+				norm_dlsf=0.;
+				for(i=0;i<dim;i++) norm_dlsf+=pow(dlsf[i],2);
+				norm_dlsf=sqrt(norm_dlsf);
+
+				if(norm_dlsf>1.e-10)
+				 for(i=0;i<dim;i++){
+					 c[i]=0.;
+					 m[i]=meltingrate*dlsf[i]/norm_dlsf;
+				 }
+				else
+				 for(i=0;i<dim;i++){
+					 c[i]=0.;
+					 m[i]=0.;
+				 }
+				break;
+
+			case CalvingHabEnum:
+				lsf_slopex_input->GetInputValue(&dlsf[0],&gauss);
+				if(dim==2) lsf_slopey_input->GetInputValue(&dlsf[1],&gauss);
+				meltingrate_input->GetInputValue(&meltingrate,&gauss);
+
+				norm_dlsf=0.;
+				for(i=0;i<dim;i++) norm_dlsf+=pow(dlsf[i],2);
+				norm_dlsf=sqrt(norm_dlsf);
+
+				if(norm_dlsf>1.e-10)
+				 for(i=0;i<dim;i++){
+					 c[i]=0.;
+					 m[i]=meltingrate*dlsf[i]/norm_dlsf;
+				 }
+				else
+				 for(i=0;i<dim;i++){
+					 c[i]=0.;
+					 m[i]=0.;
+				 }
+				break;
+
+			case CalvingCrevasseDepthEnum:
+				lsf_slopex_input->GetInputValue(&dlsf[0],&gauss);
+				if(dim==2) lsf_slopey_input->GetInputValue(&dlsf[1],&gauss);
+				meltingrate_input->GetInputValue(&meltingrate,&gauss);
+
+				if(groundedice<0) meltingrate = 0.;
+
+				norm_dlsf=0.;
+				for(i=0;i<dim;i++) norm_dlsf+=pow(dlsf[i],2);
+				norm_dlsf=sqrt(norm_dlsf);
+
+				if(norm_dlsf>1.e-10)
+				 for(i=0;i<dim;i++){
+					 c[i]=0.;
+					 m[i]=meltingrate*dlsf[i]/norm_dlsf;
+				 }
+				else
+				 for(i=0;i<dim;i++){
+					 c[i]=0.;
+					 m[i]=0.;
+				 }
+				break;
+
+			case CalvingDev2Enum:
+				  {
+					lsf_slopex_input->GetInputValue(&dlsf[0],&gauss);
+					if(dim==2) lsf_slopey_input->GetInputValue(&dlsf[1],&gauss);
+					calvingrate_input->GetInputValue(&calvingrate,&gauss);
+					meltingrate_input->GetInputValue(&meltingrate,&gauss);
+					gr_input->GetInputValue(&groundedice,&gauss);
+
+					//idea: no retreat on ice above critical calving height "calvinghaf" . Limit using regularized Heaviside function.
+					vel=sqrt(v[0]*v[0] + v[1]*v[1]);
+					haf_eps=10.;
+					if(groundedice-calvinghaf<=-haf_eps){
+						// ice floats freely below calvinghaf: calve freely
+						// undercutting has no effect:
+						meltingrate=0.;
+					}
+					else if(groundedice-calvinghaf>=haf_eps){
+						// ice is well above calvinghaf -> no calving back, i.e. limit calving rate to ice velocity
+						calvingrate=min(calvingrate,vel);
+						// ice is almost grounded: frontal undercutting has maximum effect (do nothing).
+					}
+					else{ // ice is close to calvinghaf: smooth transition between limitation and free calving.
+						//heaviside: 0 for floating, 1 for grounded
+						heaviside=(groundedice-calvinghaf+haf_eps)/(2.*haf_eps) + sin(PI*(groundedice-calvinghaf)/haf_eps)/(2.*M_PI);
+						calvingrate=heaviside*(min(calvingrate,vel)-calvingrate)+calvingrate;
+						meltingrate=heaviside*meltingrate+0.;
+					}
+
+					norm_dlsf=0.;
+					for(i=0;i<dim;i++) norm_dlsf+=pow(dlsf[i],2);
+					norm_dlsf=sqrt(norm_dlsf);
+
+					if(norm_dlsf>1.e-10)
+					 for(i=0;i<dim;i++){
+						 c[i]=calvingrate*dlsf[i]/norm_dlsf;
+						 m[i]=meltingrate*dlsf[i]/norm_dlsf;
+					 }
+					else
+					 for(i=0;i<dim;i++){
+						 c[i]=0.;
+						 m[i]=0.;
+					 }
+					break;
+				  }
+
+			default:
+				_error_("Calving law "<<EnumToStringx(calvinglaw)<<" not supported yet");
+		}
+		for(i=0;i<dim;i++) w[i]=v[i]-c[i]-m[i];
+
+		movingfrontvx[iv] = w[0];
+		movingfrontvy[iv] = w[1];		
+	}
+
+	#ifdef MICI
+	/**************************************  MICI  START ************************************/
+	/*MICI from Crawford et al. 2021:
+	 * Tice = 20C; Bf  ->  I = 3.7e-16; α = 6.9
+	 * Tice = 20C; Bn  ->  I = 5.1e-14; α = 6.0
+	 * Tice = 20C; Bh  ->  I = 3.2e-17; α = 7.2
+	 * Tice = 10C; Bn  ->  I = 6.9e-17; α = 7.3
+	 * Tice = 5C;  Bn  ->  I = 1.9e-16; α = 7.3
+	 */
+	Input* surface_input = this->GetInput(SurfaceEnum); _assert_(surface_input);
+	Input* bed_input     = this->GetInput(BedEnum);     _assert_(bed_input);
+	Input* ls_input      = this->GetInput(MaskIceLevelsetEnum);   _assert_(ls_input);
+	IssmDouble Hc,bed,ls;
+	for(int iv=0;iv<NUMVERTICES;iv++){
+		gauss.GaussVertex(iv);
+
+		surface_input->GetInputValue(&Hc,&gauss);
+		bed_input->GetInputValue(&bed,&gauss);
+		ls_input->GetInputValue(&ls,&gauss);
+
+		/*Do we assume that the calving front does not move?*/
+		//movingfrontvx[iv] = 0.;
+		//movingfrontvy[iv] = 0.;
+
+		//if(Hc>80. && bed<0. && fabs(ls)<100.e3){ //Pollard & De Conto
+		if(Hc>135. && bed<0. && fabs(ls)<100.e3){ // Crawford et all
+
+			lsf_slopex_input->GetInputValue(&dlsf[0],&gauss);
+			norm_dlsf=0.;
+			for(i=0;i<dim;i++) norm_dlsf+=pow(dlsf[i],2);
+			norm_dlsf=sqrt(norm_dlsf);
+
+			/*use vel direction instead of LSF*/
+			vx_input->GetInputValue(&v[0],&gauss);
+			vy_input->GetInputValue(&v[1],&gauss);
+			vel=sqrt(v[0]*v[0] + v[1]*v[1]);
+			norm_dlsf = max(vel,1.e-10);
+			dlsf[0] = v[0];
+			dlsf[1] = v[1];
+
+			/*5C Bn (worst case scenario)*/
+			IssmDouble I     = 1.9e-16;
+			IssmDouble alpha = 7.3;
+			IssmDouble C = min(2000.,I*pow(Hc,alpha))/(24*3600.); /*convert from m/day to m/s*/
+			//IssmDouble C = (min(max(Hc,80.),100.) - 80.)/20. * 10./(24*3600.); /*Original MICI! convert from m/day to m/s*/
+			movingfrontvx[iv] = -C*dlsf[0]/norm_dlsf;
+			movingfrontvy[iv] = -C*dlsf[1]/norm_dlsf;
+		}
+	}
+	#endif
+	/**************************************  END MICI  *************************************/
+
+	/*Add input*/
+	this->AddInput(MovingFrontalVxEnum,&movingfrontvx[0],P1DGEnum);
+	this->AddInput(MovingFrontalVyEnum,&movingfrontvy[0],P1DGEnum);
+}
+/*}}}*/
 Gauss*     Tria::NewGauss(void){/*{{{*/
 	return new GaussTria();
@@ -3562,5 +4536,5 @@
 	int         found = 0;
 	IssmDouble  value;
-	GaussTria  *gauss = NULL;
+	GaussTria   gauss;
 
 	/*First, serarch the input: */
@@ -3574,6 +4548,6 @@
 			if(data){
 				/*ok, we are good. retrieve value of input at vertex :*/
-				gauss=new GaussTria(); gauss->GaussVertex(i);
-				data->GetInputValue(&value,gauss);
+				gauss.GaussVertex(i);
+				data->GetInputValue(&value,&gauss);
 				found=1;
 				break;
@@ -3581,7 +4555,4 @@
 		}
 	}
-
-	/*clean-up*/
-	delete gauss;
 
 	if(found)*pvalue=value;
@@ -3740,11 +4711,11 @@
 
 	/*Loop over basal nodes and update their CS*/
-	GaussTria* gauss = new GaussTria();
+	GaussTria gauss;
 	for(int i=0;i<this->NumberofNodesVelocity();i++){
 
 		if(vertexonbase[i]==1){
-			gauss->GaussNode(this->VelocityInterpolation(),i);
-			slope_input->GetInputValue(&slope,gauss);
-			groundedicelevelset_input->GetInputValue(&groundedice,gauss);
+			gauss.GaussNode(this->VelocityInterpolation(),i);
+			slope_input->GetInputValue(&slope,&gauss);
+			groundedicelevelset_input->GetInputValue(&groundedice,&gauss);
 			IssmDouble theta = atan(slope);
 
@@ -3767,5 +4738,4 @@
 	/*cleanup*/
 	xDelete<IssmDouble>(vertexonbase);
-	delete gauss;
 }
 /*}}}*/
@@ -3784,61 +4754,4 @@
 	if(this->hneighbors) this->hneighbors->reset();
 
-}
-/*}}}*/
-void       Tria::RignotMeltParameterization(){/*{{{*/
-
-   IssmDouble A, B, alpha, beta;
-	IssmDouble bed,qsg,qsg_basin,TF,yts;
-	int numbasins;
-	IssmDouble basinid[NUMVERTICES];
-	IssmDouble* basin_icefront_area=NULL;
-
-	/* Coefficients */
-	A    = 3e-4;
-	B    = 0.15;
-	alpha = 0.39;
-	beta = 1.18;
-
-	/*Get inputs*/
-	Input* bed_input = this->GetInput(BedEnum);                     _assert_(bed_input);
-	Input* qsg_input = this->GetInput(FrontalForcingsSubglacialDischargeEnum);		 _assert_(qsg_input);
-	Input* TF_input  = this->GetInput(FrontalForcingsThermalForcingEnum);          _assert_(TF_input);
-	Element::GetInputListOnVertices(&basinid[0],FrontalForcingsBasinIdEnum);
-
-	this->FindParam(&yts, ConstantsYtsEnum);
-	this->parameters->FindParam(&numbasins,FrontalForcingsNumberofBasinsEnum);
-	this->parameters->FindParam(&basin_icefront_area,&numbasins,FrontalForcingsBasinIcefrontAreaEnum);
-
-	IssmDouble meltrates[NUMVERTICES];  //frontal melt-rate
-
-	/* Start looping on the number of vertices: */
-	GaussTria* gauss=new GaussTria();
-	for(int iv=0;iv<NUMVERTICES;iv++){
-		gauss->GaussVertex(iv);
-
-		/* Get variables */
-		bed_input->GetInputValue(&bed,gauss);
-		qsg_input->GetInputValue(&qsg,gauss);
-		TF_input->GetInputValue(&TF,gauss);
-
-		if(basin_icefront_area[reCast<int>(basinid[iv])-1]==0.) meltrates[iv]=0.;
-		else{
-			/* change the unit of qsg (m^3/d -> m/d) with ice front area */
-			qsg_basin=qsg/basin_icefront_area[reCast<int>(basinid[iv])-1];
-
-			/* calculate melt rates */
-			meltrates[iv]=((A*max(-bed,0.)*pow(max(qsg_basin,0.),alpha)+B)*pow(max(TF,0.),beta))/86400; //[m/s]
-		}
-
-		if(xIsNan<IssmDouble>(meltrates[iv])) _error_("NaN found in vector");
-		if(xIsInf<IssmDouble>(meltrates[iv])) _error_("Inf found in vector");
-	}
-
-	/*Add input*/
-	this->AddInput(CalvingMeltingrateEnum,&meltrates[0],P1Enum);
-
-	/*Cleanup and return*/
-	xDelete<IssmDouble>(basin_icefront_area);
-	delete gauss;
 }
 /*}}}*/
@@ -3950,4 +4863,19 @@
 }
 /*}}}*/
+void       Tria::SetElementInput(int enum_in,IssmDouble value,int type){/*{{{*/
+
+	if(type==P0Enum){
+		this->inputs->SetTriaInput(enum_in,P0Enum,this->lid,value);
+	}
+	else if(type==P1Enum){
+		IssmDouble values[3]; 
+		for(int i=0;i<3;i++)values[i]=value;
+		int lidlist[3];
+		this->GetVerticesLidList(&lidlist[0]);
+		this->inputs->SetTriaInput(enum_in,P1Enum,3,&lidlist[0],&values[0]);
+	}
+	else _error_("interpolation type not supported yet");
+}
+/*}}}*/
 void       Tria::SetElementInput(Inputs* inputs,int numindices,int* indices,IssmDouble* values,int enum_in){/*{{{*/
 
@@ -3965,4 +4893,5 @@
 	switch(domaintype){
 		case Domain2DhorizontalEnum:
+		case Domain3DsurfaceEnum:
 			return this;
 		case Domain2DverticalEnum:
@@ -4025,8 +4954,16 @@
 }
 /*}}}*/
+bool       Tria::IsSpawnedElement(void){/*{{{*/
+
+	if(this->iscollapsed!=0){
+		return true;
+	}
+
+	return false;
+
+}/*}}}*/
 void       Tria::StrainRateparallel(){/*{{{*/
 
 	IssmDouble  epsilon[3];
-	GaussTria* gauss=NULL;
 	IssmDouble  vx,vy,vel;
 	IssmDouble  strainxx;
@@ -4044,15 +4981,15 @@
 
 	/* Start looping on the number of vertices: */
-	gauss=new GaussTria();
+	GaussTria gauss;
 	for (int iv=0;iv<NUMVERTICES;iv++){
-		gauss->GaussVertex(iv);
+		gauss.GaussVertex(iv);
 
 		/* Get the value we need*/
-		vx_input->GetInputValue(&vx,gauss);
-		vy_input->GetInputValue(&vy,gauss);
+		vx_input->GetInputValue(&vx,&gauss);
+		vy_input->GetInputValue(&vy,&gauss);
 		vel=vx*vx+vy*vy;
 
 		/*Compute strain rate viscosity and pressure: */
-		this->StrainRateSSA(&epsilon[0],&xyz_list[0][0],gauss,vx_input,vy_input);
+		this->StrainRateSSA(&epsilon[0],&xyz_list[0][0],&gauss,vx_input,vy_input);
 		strainxx=epsilon[0];
 		strainyy=epsilon[1];
@@ -4065,12 +5002,8 @@
 	/*Add input*/
 	this->AddInput(StrainRateparallelEnum,&strainparallel[0],P1DGEnum);
-
-	/*Clean up and return*/
-	delete gauss;
 }
 /*}}}*/
 void       Tria::StrainRateperpendicular(){/*{{{*/
 
-	GaussTria* gauss=NULL;
 	IssmDouble  epsilon[3];
 	IssmDouble  vx,vy,vel;
@@ -4089,15 +5022,15 @@
 
 	/* Start looping on the number of vertices: */
-	gauss=new GaussTria();
+	GaussTria gauss;
 	for (int iv=0;iv<NUMVERTICES;iv++){
-		gauss->GaussVertex(iv);
+		gauss.GaussVertex(iv);
 
 		/* Get the value we need*/
-		vx_input->GetInputValue(&vx,gauss);
-		vy_input->GetInputValue(&vy,gauss);
+		vx_input->GetInputValue(&vx,&gauss);
+		vy_input->GetInputValue(&vy,&gauss);
 		vel=vx*vx+vy*vy;
 
 		/*Compute strain rate viscosity and pressure: */
-		this->StrainRateSSA(&epsilon[0],&xyz_list[0][0],gauss,vx_input,vy_input);
+		this->StrainRateSSA(&epsilon[0],&xyz_list[0][0],&gauss,vx_input,vy_input);
 		strainxx=epsilon[0];
 		strainyy=epsilon[1];
@@ -4110,7 +5043,4 @@
 	/*Add input*/
 	this->AddInput(StrainRateperpendicularEnum,&strainperpendicular[0],P1DGEnum);
-
-	/*Clean up and return*/
-	delete gauss;
 }
 /*}}}*/
@@ -4179,5 +5109,5 @@
 
 	/*CFL criterion: */
-	IssmDouble dt = C/(maxabsvx/dx+maxabsvy/dy);
+	IssmDouble dt = C/(maxabsvx/dx+maxabsvy/dy + 1.e-18);
 
 	return dt;
@@ -4543,4 +5473,5 @@
 	IssmDouble base,smb,rho_ice,scalefactor;
 	IssmDouble Total_Smb=0;
+	IssmDouble lsf[NUMVERTICES];
 	IssmDouble xyz_list[NUMVERTICES][3];
 
@@ -4556,15 +5487,45 @@
 	 * base = 1/2 abs((xA-xC)(yB-yA)-(xA-xB)(yC-yA))*/
 	base = 1./2. * fabs((xyz_list[0][0]-xyz_list[2][0])*(xyz_list[1][1]-xyz_list[0][1]) - (xyz_list[0][0]-xyz_list[1][0])*(xyz_list[2][1]-xyz_list[0][1]));	// area of element in m2
-
+	
 	/*Now get the average SMB over the element*/
-	Input* smb_input = this->GetInput(SmbMassBalanceEnum); _assert_(smb_input);
-	smb_input->GetInputAverage(&smb);	// average smb on element in m ice s-1
-	if(scaled==true){
-		Input* scalefactor_input = this->GetInput(MeshScaleFactorEnum); _assert_(scalefactor_input);
-		scalefactor_input->GetInputAverage(&scalefactor);// average scalefactor on element
+	Element::GetInputListOnVertices(&lsf[0],MaskIceLevelsetEnum);
+	if(lsf[0]*lsf[1]<=0 || lsf[0]*lsf[2]<=0 || lsf[1]*lsf[2]<=0){
+		/*Partially ice-covered element*/
+		bool mainlyice;
+      int point;
+      IssmDouble* weights       = xNew<IssmDouble>(NUMVERTICES);
+      IssmDouble* smb_vertices  = xNew<IssmDouble>(NUMVERTICES);
+      IssmDouble f1,f2,phi;
+		
+		Element::GetInputListOnVertices(&smb_vertices[0],SmbMassBalanceEnum);
+		GetFractionGeometry(weights,&phi,&point,&f1,&f2,&mainlyice,lsf);
+		smb = 0.0;
+		for(int i=0;i<NUMVERTICES;i++) smb += weights[i]*smb_vertices[i];
+	
+		if(scaled==true){
+         IssmDouble* scalefactor_vertices = xNew<IssmDouble>(NUMVERTICES);
+         Element::GetInputListOnVertices(&scalefactor_vertices[0],MeshScaleFactorEnum);
+         scalefactor = 0.0;
+         for(int i=0;i<NUMVERTICES;i++) scalefactor += weights[i]/phi*scalefactor_vertices[i];
+         xDelete<IssmDouble>(scalefactor_vertices);
+      }
+		else scalefactor = 1.0;
+
+		/*Cleanup*/
+      xDelete<IssmDouble>(weights);
+      xDelete<IssmDouble>(smb_vertices);
 	}
 	else{
-		scalefactor=1.;
-	}
+		/*Fully ice-covered element*/
+		Input* smb_input = this->GetInput(SmbMassBalanceEnum); _assert_(smb_input);
+		smb_input->GetInputAverage(&smb);   // average smb on element in m ice s-1
+
+		if(scaled==true){
+			Input* scalefactor_input = this->GetInput(MeshScaleFactorEnum); _assert_(scalefactor_input);
+			scalefactor_input->GetInputAverage(&scalefactor);// average scalefactor on element
+		}
+		else scalefactor=1.0;
+	}
+	
    Total_Smb=rho_ice*base*smb*scalefactor;	// smb on element in kg s-1
 
@@ -4730,14 +5691,13 @@
 	Input* onbase = this->GetInput(MeshVertexonbaseEnum); _assert_(onbase);
 
-	GaussTria* gauss=new GaussTria();
+	GaussTria gauss;
 	for(int iv=0;iv<this->NumberofNodes(this->element_type);iv++){
-		gauss->GaussNode(this->element_type,iv);
-		onbase->GetInputValue(&isonbase,gauss);
+		gauss.GaussNode(this->element_type,iv);
+		onbase->GetInputValue(&isonbase,&gauss);
 		if(isonbase==1.){
-			input->GetInputValue(&value,gauss);
+			input->GetInputValue(&value,&gauss);
 			this->nodes[iv]->ApplyConstraint(0,value);
 		}
 	}
-	delete gauss;
 
 }
@@ -4754,14 +5714,13 @@
 	Input* onsurf = this->GetInput(MeshVertexonsurfaceEnum); _assert_(onsurf);
 
-	GaussTria* gauss=new GaussTria();
+	GaussTria gauss;
 	for(int iv=0;iv<this->NumberofNodes(this->element_type);iv++){
-		gauss->GaussNode(this->element_type,iv);
-		onsurf->GetInputValue(&isonsurface,gauss);
+		gauss.GaussNode(this->element_type,iv);
+		onsurf->GetInputValue(&isonsurface,&gauss);
 		if(isonsurface==1.){
-			input->GetInputValue(&value,gauss);
+			input->GetInputValue(&value,&gauss);
 			this->nodes[iv]->ApplyConstraint(0,value);
 		}
 	}
-	delete gauss;
 }
 /*}}}*/
